--
-- OpenCarterDX
--
-- written by fruktor, visit: www.eifok-team.de
--

OpenCarterDX = {};

OpenCarterDX.modDir = g_currentModDirectory;

function OpenCarterDX.prerequisitesPresent(specializations)
    return true; 
end;

function OpenCarterDX:load(xmlFile)

	self.playerCallBackCarterDX = SpecializationUtil.callSpecializationsFunction("playerCallBackCarterDX"); 
	
	self.doorDXO = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(xmlFile, string.format("vehicle.openCarterDX#trigger")) );
	if trigger == nil then
		print("[Error::OpenCarterDX] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(xmlFile, string.format("vehicle.openCarterDX#icIndex", i));
	
	self.doorDXO.icIndex = icIndex;
	self.doorDXO.trigger = trigger;
	self.doorDXO.plIR = false;
		
	addTrigger( trigger, "playerCallBackCarterDX", self );				
	
end;

function OpenCarterDX:delete()
	if self.doorDXO.trigger ~= nil then
		removeTrigger(self.doorDXO.trigger);
	end;
end;

function OpenCarterDX:readStream(streamId, connection)
end;

function OpenCarterDX:writeStream(streamId, connection)
end;

function OpenCarterDX:mouseEvent(posX, posY, isDown, isUp, button)
end;

function OpenCarterDX:keyEvent(unicode, sym, modifier, isDown)
end;

function OpenCarterDX:update(dt)
	
	if self.doorDXO.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_OPENCARTERDX"), InputBinding.SET_OPENCARTERDX );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_OPENCARTERDX") );
		if InputBinding.hasEvent(InputBinding.SET_OPENCARTERDX)then
			local obj = self.interactiveObjects[self.doorDXO.icIndex];
			if obj ~= nil then
				--self.setDoor(not obj.isOpen);
				self:doActionOnObject(self.doorDXO.icIndex);
			end;
			
			--self.vehicle:playAnimation(self.animation, dir, Utils.clamp(self.vehicle:getAnimationTime(self.animation), 0, 1), true);
		end
	end;
end;

function OpenCarterDX:onLeave()
end;

function OpenCarterDX:draw()
end;

function OpenCarterDX:playerCallBackCarterDX(triggerId, otherId, onEnter, onLeave, onStay)
	
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorDXO.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorDXO.plIR = false;
	end;
	
end;

