--
-- OpenCarterSX
--
-- written by fruktor, visit: www.eifok-team.de
--

OpenCarterSX = {};

OpenCarterSX.modDir = g_currentModDirectory;

function OpenCarterSX.prerequisitesPresent(specializations)
    return true; 
end;

function OpenCarterSX:load(xmlFile)

	self.playerCallBackCarterSX = SpecializationUtil.callSpecializationsFunction("playerCallBackCarterSX"); 
	
	self.doorSXO = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(xmlFile, string.format("vehicle.openCarterSx#trigger")) );
	if trigger == nil then
		print("[Error::OpenCarterSX] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(xmlFile, string.format("vehicle.openCarterSx#icIndex", i));
	
	self.doorSXO.icIndex = icIndex;
	self.doorSXO.trigger = trigger;
	self.doorSXO.plIR = false;
		
	addTrigger( trigger, "playerCallBackCarterSX", self );				
	
end;

function OpenCarterSX:delete()
	if self.doorSXO.trigger ~= nil then
		removeTrigger(self.doorSXO.trigger);
	end;
end;

function OpenCarterSX:readStream(streamId, connection)
end;

function OpenCarterSX:writeStream(streamId, connection)
end;

function OpenCarterSX:mouseEvent(posX, posY, isDown, isUp, button)
end;

function OpenCarterSX:keyEvent(unicode, sym, modifier, isDown)
end;

function OpenCarterSX:update(dt)
	
	if self.doorSXO.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_OPENCARTERSX"), InputBinding.SET_OPENCARTERSX );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_OPENCARTERSX") );
		if InputBinding.hasEvent(InputBinding.SET_OPENCARTERSX)then
			local obj = self.interactiveObjects[self.doorSXO.icIndex];
			if obj ~= nil then
				--self.setDoor(not obj.isOpen);
				self:doActionOnObject(self.doorSXO.icIndex);
			end;
			
			--self.vehicle:playAnimation(self.animation, dir, Utils.clamp(self.vehicle:getAnimationTime(self.animation), 0, 1), true);
		end
	end;
end;

function OpenCarterSX:onLeave()
end;

function OpenCarterSX:draw()
end;

function OpenCarterSX:playerCallBackCarterSX(triggerId, otherId, onEnter, onLeave, onStay)
	
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorSXO.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorSXO.plIR = false;
	end;
	
end;

