

keilriemen = {};

function keilriemen.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function keilriemen:load(xmlFile)

    keilriemen.loadkeilriemens(self, xmlFile);

    --[[local keilriemenSound = getXMLString(xmlFile, "vehicle.keilriemenSound#file");
    if keilriemenSound ~= nil and keilriemenSound ~= "" then
        keilriemenSound = Utils.getFilename(keilriemenSound, self.baseDirectory);
        self.keilriemenSound = createSample("keilriemenSound");
        self.keilriemenSoundEnabled = false;
        loadSample(self.keilriemenSound, keilriemenSound, false);
        self.keilriemenSoundPitch = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.keilriemenSound#pitchOffset"), 1);
        self.keilriemenSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.keilriemenSound#volume"), 1);
    else
        self.keilriemenSoundPitch = 1;
        self.keilriemenSoundVolume = 1;
    end;]]


    -- motor
    self.motor1Active = false;
    self.motor2Active = false;      
    self.delayOnLeft = 0;
    self.delayOffLeft = 0;
    self.delayOnRight = 0;
    self.delayOffRight = 0;
    self.delayKurs1 = 0;
    self.delayKurs2 = 0;
    self.delayOn = 0;
    self.delayOff = 0;
    self.deltafo = 0;

    local motor1Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.motor1#index"));
    if motor1Node ~= nil then
        self.motor1 = {};
        self.motor1.node = motor1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.motor1#minRot"));
        self.motor1.minRot = {};
        self.motor1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.motor1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.motor1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.motor1#maxRot"));
        self.motor1.maxRot = {};
        self.motor1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.motor1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.motor1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.motor1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.motor1#rotTime"), 2)*70;
        self.motor1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.motor1#touchRotLimit"), 10));
    end;

    local motor2Node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.motor2#index"));
    if motor2Node ~= nil then
        self.motor2 = {};
        self.motor2.node = motor2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.motor2#minRot"));
        self.motor2.minRot = {};
        self.motor2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.motor2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.motor2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.motor2#maxRot"));
        self.motor2.maxRot = {};
        self.motor2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.motor2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.motor2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.motor2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.motor2#rotTime"), 2)*70;
        self.motor2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.motor2#touchRotLimit"), 10));
    end;
    self.movingFlag = self:getNextDirtyFlag();

end;

function keilriemen:loadkeilriemens(xmlFile)
    self.keilriemens = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.keilriemen.keilriemen(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
            break;
        end;
        local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
        local speedRefNode = Utils.getNoNil(Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#speedRefNode")), node);
        local scrollSpeed = Utils.getNoNil(getXMLFloat(xmlFile, key.."#scrollSpeed"), 1);
        local shaderParameterName = Utils.getNoNil(getXMLString(xmlFile, key.."#shaderParameterName"), "scrollPosition");
        local shaderParameterComponent = Utils.getNoNil(getXMLInt(xmlFile, key.."#shaderParameterComponent"), 1);
        local scrollLength = Utils.getNoNil(getXMLFloat(xmlFile, key.."#scrollLength"), 1);
		local constSpeed = Utils.getNoNil(getXMLBool(xmlFile, key.."#constSpeed"),false);
        if node ~= nil then
            local rotatingParts = {};
            local j = 0;
            while true do
                local keyRotation = key..string.format(".rotatingPart(%d)", j);
                if not hasXMLProperty(xmlFile, keyRotation) then
                    break;
                end;
                local rotationNode = Utils.indexToObject(self.components, getXMLString(xmlFile, keyRotation.."#index"));
                local speedScale = getXMLFloat(xmlFile, keyRotation.."#speedScale");
				
                if speedScale == nil then
                    speedScale = 1.0/Utils.getNoNil(getXMLFloat(xmlFile, keyRotation.."#radius"), 1);
                end;
                if rotationNode ~= nil then
                    table.insert(rotatingParts, {node=rotationNode, speedScale=speedScale});
                end;
                j = j + 1;
            end;

            table.insert(self.keilriemens, {node=node, scrollSpeed=scrollSpeed, scrollPosition=0, scrollLength=scrollLength, shaderParameterName=shaderParameterName, shaderParameterComponent=shaderParameterComponent, speedRefNode=speedRefNode, rotatingParts=rotatingParts,constSpeed=constSpeed});
        end;
        i = i + 1;
    end;
end;

function keilriemen:delete()
    --[[if self.keilriemenSound ~= nil then
        delete(self.keilriemenSound);
    end;]]
end;

function keilriemen:mouseEvent(posX, posY, isDown, isUp, button)
end;

function keilriemen:keyEvent(unicode, sym, modifier, isDown)
end;

function keilriemen:update(dt)

    if self:getIsActive() and self.isMotorStarted then
        for _, keilriemen in pairs(self.keilriemens) do
            -- local newX, newY, newZ = getWorldTranslation(keilriemen.speedRefNode);
            -- if keilriemen.lastPosition == nil then
                -- keilriemen.lastPosition = {newX, newY, newZ};
            -- end;
            -- local dx, dy, dz = worldDirectionToLocal(keilriemen.speedRefNode, newX-keilriemen.lastPosition[1], newY-keilriemen.lastPosition[2], newZ-keilriemen.lastPosition[3]);
            -- local movingDirection = 0;
            -- if dz > 0.0001 then
                -- movingDirection = 1;
            -- elseif dz < -0.0001 then
                -- movingDirection = -1;
            -- end;
            -- local movedDistance = Utils.vector3Length(dx, dy, dz);
            -- keilriemen.lastPosition[1] = newX;
            -- keilriemen.lastPosition[2] = newY;
            -- keilriemen.lastPosition[3] = newZ;
			
			local movedDistance = 0;

			if keilriemen.constSpeed then
					movedDistance = 1.0;
			elseif self.isMotorStarted then				
					movedDistance = self.motor.lastMotorRpm;				
			end;

            keilriemen.scrollPosition = (keilriemen.scrollPosition + movedDistance*keilriemen.scrollSpeed) % keilriemen.scrollLength;
            if keilriemen.shaderParameterComponent == 1 then
                setShaderParameter(keilriemen.node, keilriemen.shaderParameterName, keilriemen.scrollPosition,0,0,0, false);
            else
                setShaderParameter(keilriemen.node, keilriemen.shaderParameterName, 0,keilriemen.scrollPosition,0,0, false);
            end;

            for _, rotatingPart in pairs(keilriemen.rotatingParts) do
                rotate(rotatingPart.node, 0,0, rotatingPart.speedScale * movedDistance);
            end;
        end;
    end;
        --[[if not self.keilriemenSoundEnabled then
            playSample(self.keilriemenSound, 0, 0, 0);
            self.keilriemenSoundEnabled = true;
        end;

        if self.keilriemenSound ~= nil then
            local maxDistance  = 0.15;
            if self.keilriemenSoundEnabled then
                local keilriemenVolume = Utils.clamp(( math.abs(movedDistance) / maxDistance), 0.0, 1.0);
                setSampleVolume(self.keilriemenSound, keilriemenVolume-0.75);
            end;
        end;]]

    -- motor
    
    if self.motor1Active ~= nil and self.isMotorStarted then
        if self.delayKurs1 >= 0 then
            self.delayKurs1 = self.delayKurs1 -dt;
        end;
        if self.delayKurs2 >= 0 then
            self.delayKurs2 = self.delayKurs2 -dt;
        end;

        if not self.motor1Max then
            if self.delayKurs1 < 0 then
                self.delayKurs2 = 70;
                self.motor1Max = true;
                self.motor2Max = true;
            end;
        end;

        if self.motor1Max then
            if self.delayKurs2 < 0 then
                self.delayKurs1 = 70;
                self.motor1Max = false;
                self.motor2Max = false;
            end;
        end;
            
    else
        self.motor1Max = false;
        self.motor2Max = false;
    end;

    if self.motor1 ~= nil then
        local x, y, z = getRotation(self.motor1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.motor1.maxRot, self.motor1.minRot, 3, self.motor1.rotTime, dt, not self.motor1Max);
        setRotation(self.motor1.node, unpack(newRot));
    end;

    if self.motor2 ~= nil then
        local x, y, z = getRotation(self.motor2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.motor2.maxRot, self.motor2.minRot, 3, self.motor2.rotTime, dt, not self.motor2Max);
        setRotation(self.motor2.node, unpack(newRot));
    end;

end;

function keilriemen:draw()
end;
